package cn.com.qmth.examcloud.core.oe.student.face.service;

import org.json.JSONException;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.web.multipart.commons.CommonsMultipartFile;

import cn.com.qmth.examcloud.core.oe.common.entity.ExamCaptureEntity;
import cn.com.qmth.examcloud.core.oe.common.entity.ExamCaptureQueueEntity;
import cn.com.qmth.examcloud.core.oe.student.face.service.bean.CallType;
import cn.com.qmth.examcloud.core.oe.student.face.service.bean.CompareFaceSyncInfo;

/**
 * 
 * @author  	chenken
 * @date    	2018年9月3日 下午4:42:35
 * @company 	QMTH
 * @description 考试抓拍服务接口 
 */
public interface ExamCaptureService {

    //face++人脸比对失败时，需要将状态置为失败，并清空批次号
    void disposeFaceCompareFaild(ExamCaptureQueueEntity examCaptureQueue);

	//百度活体检测失败时，需要将状态置为失败，并清空批次号
	void disposeBaiDuFaceLivenessFaild(ExamCaptureQueueEntity examCaptureQueue);

	void disposeBaiDuFaceLiveness(ExamCaptureQueueEntity examCaptureQueue) throws JSONException;

    @Transactional
    void saveExamCaptureAndDeleteQueue(ExamCaptureQueueEntity examCaptureQueue);

    /**
	 * 同步比较人脸:用于进入考试
	 * @param studentId			学生ID
	 * @param baseFaceToken		学生底照faceToken
	 * @param file				抓拍照片 File
	 * @return
	 */
	public CompareFaceSyncInfo compareFaceSyncByFile(Long studentId,String baseFaceToken,CommonsMultipartFile file);
	
	/**
	 * 同步比较人脸:用于进入考试
	 * @param studentId			学生ID
	 * @param baseFaceToken		学生底照faceToken
	 * @param fileUrl				抓拍照片Url
	 * @return
	 */
	public CompareFaceSyncInfo compareFaceSyncByFileUrl(Long studentId,String baseFaceToken,String fileUrl);

	/**
	 * 获取考试抓拍结果
	 * @param examRecordDataId
	 * @return
	 */
	public ExamCaptureEntity getExamCaptureResult(Long examRecordDataId,String fileName);
	/**
	 * 处理单个考试抓拍照片数据
	 * @param examCaptureQueueEntity
	 */
	void disposeFaceCompare(ExamCaptureQueueEntity examCaptureQueueEntity) throws JSONException;
}
